# rx.py  - 22.01.2022

import serial as ser
import time

port = "COM4"
baud = 2400
STARTBYTE = 0xAA

with ser.Serial(port, baud) as rx:

	msg_cnt = 100
	error_cnt = 0
	success_cnt = 0

	print("start")

	while rx.in_waiting:
		rx.read()
	# rx.flush()

	while msg_cnt:

		if rx.in_waiting:

			buffer = bytearray()
			error = 0

			while rx.in_waiting:
				buffer.append(rx.read()[0])

				if not rx.in_waiting:
					time.sleep(.005)

			# Den Datenbereich ausgeben
			# print(buffer[2:-1])

			checksum = 0
			for i in range(len(buffer)):
				checksum += buffer[i]
			checksum %= 256

			try:
				if not buffer[0] == STARTBYTE:
					# print(f"Error Startbyte {buffer[0]}, expecting '{STARTBYTE}'")
					error |= 1

				if not buffer[1] == len(buffer):
					# print(f"Error Lenght {len(buffer)}, expecting {buffer[1]}") 
					error |= 2

				if not checksum == 0xFF:
					# print(f"Error Checksum")
					error |= 4
			except:
				error |= 8

			if not error:
				# print("  ok")
				print("+", end = "")
				success_cnt += 1
			else:
				error_cnt += 1
				print(f"{error}", end = "")
			msg_cnt -= 1

		time.sleep(.01)
		# print(".", end = "")
print()
print(f"success: {success_cnt}, errors: {error_cnt}")
print("done")
